package de.hendriklipka.pdfconv;

public class DefaultLogger implements LogHandler
{
    private boolean _verbose=false;
    private boolean _debug=false;

    public DefaultLogger(boolean verbose, boolean debug)
    {
        _verbose=verbose;
        _debug=debug;
    }
    
    public void setFileName(String name)
    {
        System.out.println("processing file "+name);
    }

    public void setFileCount(int files)
    {
        System.out.println("file count: "+files);
    }

    public void setCurrentFile(int file)
    {
        System.out.println("processing file #"+file);
    }

    public void setPageCount(int pages)
    {
        System.out.println("page count: "+pages);
    }

    public void setCurrentPage(int page)
    {
        System.out.println("processing page #"+page);
    }

    public void printError(String msg)
    {
        System.err.println("ERROR: "+msg);
    }

    public void printWarn(String msg)
    {
        System.err.println("WARN: "+msg);
    }

    public void printMessage(String msg)
    {
        System.out.println("msg");
    }

    public void printVerbose(String msg)
    {
        if (_verbose)
            System.out.println("msg");
    }

    public void printDebug(String msg)
    {
        if (_debug)
            System.out.println("msg");
    }

    public void endDocument()
    {
        if (_verbose)
            System.out.println("document finished");
    }

    public void endDocuments()
    {
        System.out.println("finished");
    }
}
