package de.hendriklipka.pdfconv.gui;

import com.jgoodies.plaf.plastic.PlasticLookAndFeel;
import com.jgoodies.plaf.plastic.Plastic3DLookAndFeel;
import com.jgoodies.plaf.plastic.PlasticXPLookAndFeel;
import com.jgoodies.plaf.Options;
import com.jgoodies.plaf.FontSizeHints;

import javax.swing.*;

public class GUIMain
{
    WizardComponentImpl _wizard=new WizardComponentImpl();

    public static void main(String[] args)
    {
        if (args.length>0)
        {
            String arg=args[0];
            try
            {
                if (arg.equals("-win"))
                {
                    UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                    UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
                }
                else if (arg.equals("-mac"))
                {
                    UIManager.setLookAndFeel("apple.laf.AquaLookAndFeel");
                    UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
                }
                else if (arg.equals("-metal"))
                {
                    UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
                    UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
                }
                else if (arg.equals("-none"))
                {
                }
                else if (arg.equals("-plastic"))
                {
                    UIManager.setLookAndFeel("com.jgoodies.plaf.plastic.PlasticLookAndFeel");
                    Options.setGlobalFontSizeHints(FontSizeHints.MIXED);
                    PlasticLookAndFeel.setFontSizeHints(FontSizeHints.SYSTEM);
                    UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
                }
                else if (arg.equals("-plastic3d"))
                {
                    UIManager.setLookAndFeel("com.jgoodies.plaf.plastic.Plastic3DLookAndFeel");
                    Options.setGlobalFontSizeHints(FontSizeHints.MIXED);
                    Plastic3DLookAndFeel.setFontSizeHints(FontSizeHints.SYSTEM);
                    UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
                }
                else if (arg.equals("-plasticxp"))
                {
                    UIManager.setLookAndFeel("com.jgoodies.plaf.plastic.PlasticXPLookAndFeel");
                    Options.setGlobalFontSizeHints(FontSizeHints.MIXED);
                    PlasticXPLookAndFeel.setFontSizeHints(FontSizeHints.SYSTEM);
                    UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
                }
            }
            catch (Exception e)
            {
            }
        }
        else
        {
            try
            {
                UIManager.setLookAndFeel("com.jgoodies.plaf.plastic.Plastic3DLookAndFeel");
                Options.setGlobalFontSizeHints(FontSizeHints.MIXED);
                PlasticLookAndFeel.setFontSizeHints(FontSizeHints.SYSTEM);
                UIManager.put(Options.USE_SYSTEM_FONTS_APP_KEY, Boolean.TRUE);
            }
            catch (ClassNotFoundException e)
            {
            }
            catch (InstantiationException e)
            {
                e.printStackTrace();  //To change body of catch statement use Options | File Templates.
            }
            catch (IllegalAccessException e)
            {
                e.printStackTrace();  //To change body of catch statement use Options | File Templates.
            }
            catch (UnsupportedLookAndFeelException e)
            {
                e.printStackTrace();  //To change body of catch statement use Options | File Templates.
            }
        }
        GUIMain main=new GUIMain();
        main.doGui();
    }

    private GUIMain()
    {
        SelectActionPage selectActionPage=new SelectActionPage(null);
        SelectFilesPage selectFilesPage=new SelectFilesPage(null);
        ImageOptionsPage imageOptionsPage=new ImageOptionsPage(null);
        ShowProgressPage showProgressPage=new ShowProgressPage(null);
        OutputOptionsPage outputOptionsPage=new OutputOptionsPage(null);
        FileTypesPage fileTypesPage=new FileTypesPage(null);

        LogicHandler handler=new GUILogicHandler(_wizard, imageOptionsPage,outputOptionsPage, fileTypesPage, selectFilesPage,
            selectActionPage, showProgressPage);

        selectActionPage.setLogicHandler(handler);
        selectFilesPage.setLogicHandler(handler);
        imageOptionsPage.setLogicHandler(handler);
        showProgressPage.setLogicHandler(handler);
        outputOptionsPage.setLogicHandler(handler);
        fileTypesPage.setLogicHandler(handler);

        _wizard.addPage(selectActionPage);
        _wizard.addPage(selectFilesPage);
        _wizard.addPage(outputOptionsPage);
        _wizard.addPage(fileTypesPage);
        _wizard.addPage(imageOptionsPage);
        _wizard.addPage(showProgressPage);
        
        _wizard.setLogicHandler(handler);
    }

    private void doGui()
    {
        _wizard.display();
    }
}
