package de.hendriklipka.pdfconv.gui;

import com.jgoodies.forms.layout.FormLayout;
import com.jgoodies.forms.layout.CellConstraints;
import com.jgoodies.forms.builder.PanelBuilder;

import javax.swing.*;

public class SelectActionPage extends BaseWizardPage
{
    JRadioButton _rbWebPage=null;
    JRadioButton _rbBookWin=null;
    JRadioButton _rbBookMac=null;
    JRadioButton _rbNTKWin=null;
    JRadioButton _rbNTKMac=null;
    JRadioButton _rbOther=null;
    ButtonGroup _actionButtonsGroup=null;
    JCheckBox _cbAdvanced=null;

    public SelectActionPage(LogicHandler logicHandler)
    {
        _logicHandler=logicHandler;
        _enabled=true;
    }

    protected void buildPanel()
    {
        FormLayout layout=new FormLayout("fill:100dlu,10dlu,fill:default:grow",
            "d,3,d,3,d,3,d,3,d,3,d,3,d,10,d,fill:0dlu:grow");

        PanelBuilder builder=new PanelBuilder(layout);
        builder.setDefaultDialogBorder();

        _panel=builder.getPanel();
        _panel.putClientProperty("jgoodies.noContentBorder", Boolean.TRUE);
        _panel.setBorder(BorderFactory.createEmptyBorder());

        CellConstraints cc=new CellConstraints();

        JTextArea jt=new JTextArea("Select what you want to do.\n\nAdditionally, specify wether you want to use the advanced options.");
        jt.setEditable(false);
        jt.setEnabled(true);
        jt.setWrapStyleWord(true);
        jt.setLineWrap(true);
        builder.add(jt, cc.xywh(1, 1, 1, 16));

        builder.addTitle("What type of files do you want to generate?", cc.xywh(3, 1, 1, 1));

        _rbWebPage=new JRadioButton("a web page");
        _rbWebPage.setFocusPainted(false);
        builder.add(_rbWebPage, cc.xy(3, 3));
        _rbBookWin=new JRadioButton("a BookMaker file for Windows");
        _rbBookWin.setFocusPainted(false);
        builder.add(_rbBookWin, cc.xy(3, 5));
        _rbBookMac=new JRadioButton("a BookMaker file for Macintosh");
        _rbBookMac.setFocusPainted(false);
        builder.add(_rbBookMac, cc.xy(3, 7));
        _rbNTKWin=new JRadioButton("a NTK book project for Windows");
        _rbNTKWin.setFocusPainted(false);
        builder.add(_rbNTKWin, cc.xy(3, 9));
        _rbNTKMac=new JRadioButton("a NTK book project for Macintosh");
        _rbNTKMac.setFocusPainted(false);
        builder.add(_rbNTKMac, cc.xy(3, 11));
        _rbOther=new JRadioButton("something else");
        _rbOther.setFocusPainted(false);
        builder.add(_rbOther, cc.xy(3, 13));

        _actionButtonsGroup=new ButtonGroup();
        _actionButtonsGroup.add(_rbWebPage);
        _actionButtonsGroup.add(_rbBookMac);
        _actionButtonsGroup.add(_rbBookWin);
        _actionButtonsGroup.add(_rbNTKMac);
        _actionButtonsGroup.add(_rbNTKWin);
        _actionButtonsGroup.add(_rbOther);
        _rbOther.setSelected(true);

        _cbAdvanced=new JCheckBox("show advanced options");
        builder.add(_cbAdvanced, cc.xy(3, 15));
        _cbAdvanced.setFocusPainted(false);

    }

    public boolean allowFinish()
    {
        return false;
    }

    public void leavePage()
    {
        if (null==_logicHandler)
            return;
        _logicHandler.enableAdvancedOptions(_cbAdvanced.isSelected());
        _logicHandler.enableCustomActions(_rbOther.isSelected());

        String type="";
        if (_rbWebPage.isSelected())
            type=PageConstants.IMG_TYPE_JPEG;
        else if (_rbBookMac.isSelected())
            type=PageConstants.IMG_TYPE_PICT;
        else if (_rbBookWin.isSelected())
            type=PageConstants.IMG_TYPE_BMP;
        else if (_rbNTKMac.isSelected())
            type=PageConstants.IMG_TYPE_PICT;
        else if (_rbNTKWin.isSelected())
            type=PageConstants.IMG_TYPE_BMP;
        else if (_rbOther.isSelected())
            type=PageConstants.IMG_TYPE_NONE;
        _logicHandler.setImageGenerationType(type);

        type = "";
        if (_rbWebPage.isSelected())
            type = PageConstants.FILE_TYPE_HTML;
        else if (_rbBookMac.isSelected())
            type = PageConstants.FILE_TYPE_BOOK_MAC;
        else if (_rbBookWin.isSelected())
            type = PageConstants.FILE_TYPE_BOOK_WIN;
        else if (_rbNTKMac.isSelected())
            type = PageConstants.FILE_TYPE_NTK_MAC;
        else if (_rbNTKWin.isSelected())
            type = PageConstants.FILE_TYPE_NTK_WIN;
        _logicHandler.setFileGenerationType(type);
    }
}
